<script setup>
import { date } from 'alga-js'
const router = useRouter()
const route = useRoute()

definePageMeta({
  middleware: ['auth', 'org']
})

const form = ref({
  id: '',
  client: '',
  clientId: '',
  organization: '',
  organizationId: '',
  name: '',
  description: '',
  isActive: true,
  isNaturalAccount: false,
  isBalancing: false,
  vFormat: '',
  elementType: 'Account',
  elementTypeId: 'A',
  tree: 'GardenWorld ElementValue (Account, etc.)',
  treeId: 101,
  processing: false,
  alert: {
    status: '',
    message: ''
  }
})

const retrieve = async () => {
  const res = await $fetch('/api/accountings/elements/'+route.params.id, {
    headers: useRequestHeaders(['cookie'])
  })
  if(res) {
    form.value = {
      id: route.params.id,
      client: res?.AD_Client_ID?.identifier || '',
      clientId: res?.AD_Client_ID?.id || '',
      organization: res?.AD_Org_ID?.identifier || '',
      organizationId: res?.AD_Org_ID?.id || '',
      name: res?.Name || '',
      description: res?.Description || '',
      isActive: res?.IsActive ?? true,
      isNaturalAccount: res?.IsNaturalAccount ?? false,
      isBalancing: res?.IsBalancing ?? false,
      vFormat: res?.VFormat || '',
      elementType: res?.ElementType?.identifier || 'Account',
      elementTypeId: res?.ElementType?.id || 'A',
      tree: res?.AD_Tree_ID?.identifier || '',
      treeId: res?.AD_Tree_ID?.id || '',
      processing: false,
      alert: {
        status: '',
        message: ''
      }
    }
  }
}
onMounted(retrieve)

const back = () => {
  router.push('/accountings/elements')
}

const save = async (record, id = '', saveType = '') => {
  const res = await $fetch('/api/accountings/elements/update', {
    method: 'PUT',
    headers: useRequestHeaders(['cookie']),
    body: {
      id: record.id,
      organizationId: record.organizationId,
      name: record.name,
      description: record.description,
      isActive: record.isActive,
      isNaturalAccount: record.isNaturalAccount,
      isBalancing: record.isBalancing,
      vFormat: record.vFormat,
      elementTypeId: record.elementTypeId,
      treeId: record.treeId,
    }
  })

  if(Number(res.status) === 200) {
    if(saveType === 'preview') {
      router.push('/accountings/elements/'+res.id+'/view')
    } else if(saveType === 'changes') {
      form.value.processing = false
      location.reload()
    } else {
      back()
    }
  } else {
    form.value.alert.status = res.status
    form.value.alert.message = res.message
    form.value.processing = false
    window.scrollTo(0, 0)
  }
}

const breadCrumb = computed(() => ([
  { link: '/accountings/elements', text: 'Chart of Accounts'},
  { link: '#', text: 'Edit Chart of Account', active: true}
]))
</script>

<template>
  <Head>
    <Title>Edit Chart of Account</Title>
  </Head>

  <NuxtLayout name="new-dash">
    <NewBreadCrumb :items="breadCrumb" />
    <div>
      <div class="banner">
        <div class="d-flex justify-between mb-3">
          <h4></h4>
          <div class="d-flex gap-0.75rem">
            <button type="button" @click="back" class="button">
              <span class="tf-icon ti ti-chevron-left ti-xs me-1"></span> Back
            </button>
          </div>
        </div>
        <div>
          <AccountingsElementForm v-model="form" @save="save"/>
        </div>
      </div>

    </div>
  </NuxtLayout>
</template>